<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
    <style>
      .first {
        width: 100%;
        height: 1000px;
        background: #ccc;
      }

      .second {
        width: 100%;
        height: 1000px;
        background: #999;
      }
    </style>
  </head>
  <body>
    <div class="first">
      <button
        type="button"
        onclick="smoothScroll(document.getElementById('second'))"
      >
        Click Me!
      </button>
    </div>
    <div class="second" id="second">Hi</div>
    <script>
      window.smoothScroll = function (target) {
        var scrollContainer = target;
        do {
          //find scroll container
          scrollContainer = scrollContainer.parentNode;
          if (!scrollContainer) return;
          scrollContainer.scrollTop += 1;
        } while (scrollContainer.scrollTop == 0);

        var targetY = 0;
        do {
          //find the top of target relatively to the container
          if (target == scrollContainer) break;
          targetY += target.offsetTop;
        } while ((target = target.offsetParent));

        scroll = function (c, a, b, i) {
          i++;
          if (i > 30) return;
          c.scrollTop = a + ((b - a) / 30) * i;
          setTimeout(function () {
            scroll(c, a, b, i);
          }, 20);
        };
        // start scrolling
        scroll(scrollContainer, scrollContainer.scrollTop, targetY, 0);
      };
    </script>
  </body>
</html>
